/*********************************************************************************************************************
* DAVE APP Name : COMP_REF       APP Version: 4.1.4
*
* NOTE:
* This file is generated by DAVE. Any manual modification done to this file will be lost when the code is regenerated.
*********************************************************************************************************************/

/**
 * @cond
 ***********************************************************************************************************************
 *
 * Copyright (c) 2015, Infineon Technologies AG
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,are permitted provided that the
 * following conditions are met:
 *
 *   Redistributions of source code must retain the above copyright notice, this list of conditions and the  following
 *   disclaimer.
 *
 *   Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following
 *   disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *   Neither the name of the copyright holders nor the names of its contributors may be used to endorse or promote
 *   products derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE  FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT  OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * To improve the quality of the software, users are encouraged to share modifications, enhancements or bug fixes
 * with Infineon Technologies AG (dave@infineon.com).
 ***********************************************************************************************************************
 *
 * Change History
 * --------------
 *
 * 2015-02-14:
 *     - Initial version for DAVEv4
 *
 * 2015-06-20:
 *     - Copyright information updated.
 *
 * 2015-07-01:
 *     - Solver variables pdisc and hwsel_hw are read.  
 *
 * 2015-07-06:
 *     - Intensity calculation is corrected. 
 *
 * 2015-11-13:
 *     -  To support ANALOG_IO APP, is_inp_enabled, is_inn_enabled, analog_io_inp_ptr and analog_io_inn_ptr 
 *        variables are conditionally defined.
 *
 * 2015-03-12:
 *     -   GPIO mode accommodates XMC1400 ALT8 and ALT9 alternate functions.
 * @endcond
 *
 */

/***********************************************************************************************************************
 * HEADER FILES
 **********************************************************************************************************************/
#include "comp_ref.h"

/**********************************************************************************************************************
* DATA STRUCTURES
**********************************************************************************************************************/


/******************** Start of COMP_REF instance - COMP_REF_0 ********************/


const XMC_ACMP_CONFIG_t COMP_REF_0_comp_module_config =
{
  .filter_disable             = false,
  .output_invert              = true,
  .hysteresis                 = XMC_ACMP_HYSTERESIS_10
};

COMP_REF_CONFIG_t COMP_REF_0_config =
{
  .eru_used                   = false,
  .ref_source                 = COMP_REF_SOURCE_EXTERNAL,
  .is_inp_enabled             = false,
  .is_inn_enabled             = true,

  .global_acmp_handle         = &GLOBAL_ACMP_0,
  .comp_module_ptr            = (XMC_ACMP_t*) COMPARATOR, /**< ACMP base address */
  .comp_instance              = 2U,
  .comp_module_config         = &COMP_REF_0_comp_module_config,
};

COMP_REF_t COMP_REF_0 =
{
  .config                     = &COMP_REF_0_config,

  .analog_io_inp_ptr          = NULL,
  .analog_io_inn_ptr          = &ANALOG_IO_0,

  .state                      = COMP_REF_UNINITIALIZED
};
/******************** End of COMP_REF instance - COMP_REF_0 ********************/

