/*********************************************************************************************************************
* DAVE APP Name : GLOBAL_BCCU       APP Version: 4.1.4
*
* NOTE:
* This file is generated by DAVE. Any manual modification done to this file will be lost when the code is regenerated.
*********************************************************************************************************************/

/**
 * @cond
 ***********************************************************************************************************************
 *
 * Copyright (c) 2015, Infineon Technologies AG
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without modification,are permitted provided that the
 * following conditions are met:
 *
 *   Redistributions of source code must retain the above copyright notice, this list of conditions and the  following
 *   disclaimer.
 *
 *   Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the
 *   following disclaimer in the documentation and/or other materials provided with the distribution.
 *
 *   Neither the name of the copyright holders nor the names of its contributors may be used to endorse or promote
 *   products derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE  FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT  OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * To improve the quality of the software, users are encouraged to share modifications, enhancements or bug fixes
 * with Infineon Technologies AG (dave@infineon.com).
 ***********************************************************************************************************************
 *
 * Change History
 * --------------
 *
 * 2015-02-16:
 *     - Initial version<br>
 * 2015-03-27
 *      - Dummy read safely handled.<br>
 *      - Maps are used to reduce the if-else statements to assign combo options.<br>
 *      - Trap edge configuration is added.<br>
 *      - code comments added.<br>
 *      - Template coding guidelines ensured.<br>
 * 
 * 2015-07-14
 *      - trigger delay configuration bug fixed.
 *
 * @endcond
 *
 */
/***********************************************************************************************************************
 * HEADER FILES
 **********************************************************************************************************************/
#include "global_bccu.h"

XMC_BCCU_GLOBAL_CONFIG_t confighandle =
{
  .trig_mode = 	XMC_BCCU_TRIGMODE0,

  .trig_delay = XMC_BCCU_TRIGDELAY_NO_DELAY,

  .maxzero_at_output = 1000U,
  .fclk_ps = 64U,
  .dclk_ps = 219U,
  .bclk_sel = XMC_BCCU_BCLK_MODE_NORMAL,

  .global_dimlevel = 0U 
};
   
GLOBAL_BCCU_t GLOBAL_BCCU_0 = 
{
  .bccuregs = BCCU0,
  .config = &confighandle,
  .enable_events = 0U,
  .trap_source = XMC_BCCU_CH_TRAP_INA,
  .trap_edge = XMC_BCCU_CH_TRAP_EDGE_RISING,
  .init_status = false
}; 
